commit 105428c561bd5c569953dca0104fcaf3ce4bc174
Author: Bernd Bleßmann <bernd@kivitendo-premium.de>
Date:   Tue Jan 24 18:05:27 2017 +0100

    CsvImport: nicht mehr benutzte Templates des synchronen Csv-Imports entfernen.

diff --git a/templates/webpages/csv_import/_errors.html b/templates/webpages/csv_import/_errors.html
deleted file mode 100644
index 1a7d661cf..000000000
--- a/templates/webpages/csv_import/_errors.html
+++ /dev/null
@@ -1,20 +0,0 @@
-[% USE LxERP %]
-
-<h3>[%- LxERP.t8('Errors') %]</h3>
-
-<p>[%- LxERP.t8('Found #1 errors.', SELF.errors.size) %]</p>
-
-<table>
- <tr class="listheading">
-  <th>[%- LxERP.t8('Line and column') %]</th>
-  <th>[%- LxERP.t8('Block') %]</th>
-  <th>[%- LxERP.t8('Error') %]</th>
- </tr>
- [% FOREACH err = SELF.errors %]
-  <tr class="listrow[% loop.count % 2 %]">
-   <td>[% err.4 %]:[% err.3 %]</td>
-   <td>[% err.0 %]</td>
-   <td>[% err.2 %]</td>
-  </tr>
- [% END %]
-</table>
diff --git a/templates/webpages/csv_import/_preview.html b/templates/webpages/csv_import/_preview.html
deleted file mode 100644
index 01fe4d9ff..000000000
--- a/templates/webpages/csv_import/_preview.html
+++ /dev/null
@@ -1,48 +0,0 @@
-[% USE HTML %]
-[% USE LxERP %]
-
-[% IF SELF.data.size %]
- <h3>
-  [%- IF SELF.import_status == 'tested' %]
-   [%- LxERP.t8('Import preview') %]
-  [%- ELSE %]
-   [%- LxERP.t8('Import result') %]
-  [%- END %]
- </h3>
-
- <table>
-  <tr class="listheading">
-   [%- FOREACH column = SELF.info_headers.headers %]
-    <th>[%- HTML.escape(column) %]</th>
-   [%- END %]
-   [%- FOREACH column = SELF.headers.headers %]
-    <th>[%- HTML.escape(column) %]</th>
-   [%- END %]
-   [%- FOREACH column = SELF.raw_data_headers.headers %]
-    <th>[%- HTML.escape(column) %]</th>
-   [%- END %]
-   <th>[%- LxERP.t8('Notes') %]</th>
-  </tr>
-
-  [%- FOREACH row = SELF.data %]
-  [%- IF (SELF.profile.get('full_preview') == 2) || ((SELF.profile.get('full_preview') == 1) && (row.errors.size || row.information.size)) || ((SELF.profile.get('full_preview') == 0) && (loop.count < 21)) %]
-  <tr class="[% IF row.errors.size %]redrow[% ELSE %]listrow[% END %][% loop.count % 2 %]">
-   [%- FOREACH method = SELF.info_headers.methods %]
-    <td>[%- HTML.escape(row.info_data.$method) %]</td>
-   [%- END %]
-   [%- FOREACH method = SELF.headers.methods %]
-    <td>[%- HTML.escape(row.object.$method) %]</td>
-   [%- END %]
-   [%- FOREACH method = SELF.raw_data_headers.headers %]
-    <td>[%- HTML.escape(row.raw_data.$method) %]</td>
-   [%- END %]
-   <td>
-    [%- FOREACH error = row.errors %][%- HTML.escape(error) %][% UNLESS loop.last %]<br>[%- END %][%- END %]
-    [%- FOREACH info  = row.information %][% IF !loop.first || row.errors.size %]<br>[%- END %][%- HTML.escape(info) %][%- END %]
-   </td>
-  </tr>
-  [%- END %]
-  [%- END %]
-
- </table>
-[%- END %]
diff --git a/templates/webpages/csv_import/_result.html b/templates/webpages/csv_import/_result.html
deleted file mode 100644
index b67bb7fbc..000000000
--- a/templates/webpages/csv_import/_result.html
+++ /dev/null
@@ -1,9 +0,0 @@
-[% USE LxERP %]
-
-<h3>[%- LxERP.t8('Import summary') %]</h3>
-
-[%- IF SELF.import_status == 'imported' %]
- <p>[%- LxERP.t8('#1 of #2 importable objects were imported.', SELF.num_imported, SELF.num_importable || 0) %]</p>
-[%- ELSE %]
- <p>[%- LxERP.t8('Found #1 objects of which #2 can be imported.', SELF.data.size || 0, SELF.num_importable || 0) %]</p>
-[%- END %]
diff --git a/templates/webpages/csv_import/_results.html b/templates/webpages/csv_import/_results.html
deleted file mode 100644
index 56ec9334a..000000000
--- a/templates/webpages/csv_import/_results.html
+++ /dev/null
@@ -1,12 +0,0 @@
-  [%- IF SELF.errors %]
-   [%- PROCESS 'csv_import/_errors.html' %]
-  [%- END %]
-
-  [%- PROCESS 'csv_import/_result.html' %]
-  [%- PROCESS 'csv_import/_preview.html' %]
-
-[% IF progress == 100 %]
-<script type='text/javascript'>
-  $(function(){ $('#action_import').show() })
-</script>
-[% END %]
diff --git a/templates/webpages/csv_import/form.html b/templates/webpages/csv_import/form.html
index 1ab545384..c3cbcac2e 100644
--- a/templates/webpages/csv_import/form.html
+++ b/templates/webpages/csv_import/form.html
@@ -338,8 +338,6 @@
  <div id='results'>
  [%- IF SELF.deferred %]
    [%- PROCESS 'csv_import/_deferred_results.html' %]
- [%- ELSIF SELF.import_status %]
-   [%- PROCESS 'csv_import/_results.html' %]
  [%- END %]
  </div>
 